/**
 **	Form.cpp - read stdin, parse cgi input
 **
 **	Written: 1999-Feb-10 grymse@alhem.net
 **/

/*
Copyright (C) 1999  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#ifdef WIN32
#else
#include <unistd.h>
#endif

#include "list.h"
#include "Parse.h"
#include "Form.h"

/*
#define DEB(x) { \
	FILE *fil = fopen("/tmp/debug","at"); \
	x; \
	fclose(fil); \
}
*/
#define DEB(x)


// CONTENT_TYPE=multipart/form-data; boundary=---------------------------80261298425718

// Form() -- request_method POST

Form::Form(void)
:m_strBoundary(NULL)
,raw(false)
{
	CGI *cgi;
	char *c_t = getenv("CONTENT_TYPE");
	char *c_l = getenv("CONTENT_LENGTH");
	int extra = 2;
	char name[200];
	char slask[8888];

	cgibase = NULL;
	current = NULL;
	*name = 0;

	if (c_t && !strncmp(c_t, "multipart/form-data",19))
	{
		Parse pa(c_t,";=");
		char *tempcmp = NULL;
		int tc = 0;
		int l = 0;
DEB(		fprintf(fil,"Form:: multipart/form-data<br>\n");)
		pa.getword(slask);
		while (*slask)
		{
DEB(			fprintf(fil,"Content-type parse: '%s'\n",slask);)
			if (!strcmp(slask,"boundary"))
			{
				m_strBoundary = new char[200];
				pa.getword(m_strBoundary);
				l = strlen(m_strBoundary);
				tempcmp = new char[l + extra];
			}
			//
			pa.getword(slask);
		}
		if (m_strBoundary)
		{
			char content_type[200];
			char current_name[200];
			char current_filename[200];
DEB(			fprintf(fil,"Form:: boundary = '%s'<br>\n",m_strBoundary);)
			fgets(slask, 200, stdin);
			while (!feof(stdin))
			{
				while (strlen(slask) && (slask[strlen(slask) - 1] == 13 || slask[strlen(slask) - 1] == 10))
					slask[strlen(slask) - 1] = 0;
				*content_type = 0;
				*current_name = 0;
				*current_filename = 0;
				if ((strstr(slask,m_strBoundary) || strstr(m_strBoundary,slask)) && strcmp(slask, m_strBoundary))
				{
					strcpy(m_strBoundary, slask);
					l = strlen(m_strBoundary);
					delete tempcmp;
					tempcmp = new char[l + extra];
				}
				if (!strcmp(slask, m_strBoundary))
				{
				// Get headers until empty line
					fgets(slask, 200, stdin);
					while (strlen(slask) && (slask[strlen(slask) - 1] == 13 || slask[strlen(slask) - 1] == 10))
						slask[strlen(slask) - 1] = 0;
					while (!feof(stdin) && *slask)
					{
DEB(						fprintf(fil,"Field header: '%s'\n",slask);)
						Parse pa(slask,";");
						pa.getword(slask);
						if (!strcmp(slask,"Content-type:"))
						{
							pa.getword(content_type);
						}
						else
						if (!strcmp(slask,"Content-Disposition:"))
						{
							pa.getword(slask);
							if (!strcmp(slask,"form-data"))
							{
DEB(								fprintf(fil,"Form:: Content-Disposition: form-data;<br>\n");)
								pa.EnableQuote(true);
								pa.getword(slask);
								while (*slask)
								{
									Parse pa2(slask,"=");
									pa2.getword(name); // 'name' or 'filename'
									pa2.getrest(slask); // value
									if (!strcmp(name,"name"))
									{
										if (*slask == '"')
										{
											strcpy(current_name, slask + 1);
											current_name[strlen(current_name) - 1] = 0;
										}
										else
										{
											strcpy(current_name,slask);
										}
DEB(										fprintf(fil,"Form:: name = '%s'<br>\n",current_name);)
									}
									else
									if (!strcmp(name,"filename"))
									{
										if (*slask == '"')
										{
											strcpy(current_filename, slask + 1);
											current_filename[strlen(current_filename) - 1] = 0;
										}
										else
										{
											strcpy(current_filename,slask);
										}
DEB(										fprintf(fil,"Form:: filename = '%s'<br>\n",current_filename);)
										int x = -1;
										for (int i = 0; i < (int)strlen(current_filename); i++)
										{
											if (current_filename[i] == '/' || current_filename[i] == '\\')
												x = i + 1;
										}
										if (x > -1)
										{
											memmove(current_filename,current_filename + x,strlen(current_filename + x) + 1);
										}
									}
									pa.getword(slask);
								}
							}
						}
						// get next header value
						fgets(slask, 200, stdin);
						while (strlen(slask) && (slask[strlen(slask) - 1] == 13 || slask[strlen(slask) - 1] == 10))
							slask[strlen(slask) - 1] = 0;
					}
				// Read content, save...?
					if (!*current_filename) // not a file
					{
						std::string val;
						fgets(slask,1000,stdin);
						while (!feof(stdin) && strncmp(slask,m_strBoundary,strlen(m_strBoundary)))
						{
DEB(							fprintf(fil," * Content: %s",slask);)
							val += slask;
							fgets(slask,1000,stdin);
						}
DEB(						fprintf(fil," * End of Content: %s",slask);)
						// remove trailing cr/linefeed
						while (val.size() && (val[val.size() - 1] == 13 || val[val.size() - 1] == 10))
						{
							val = val.substr(0,val.size() - 1);
						}
						cgi = new CGI;
						cgi -> name = new char[strlen(current_name) + 1];
						strcpy(cgi -> name,current_name);
						cgi -> value = new char[val.size() + 1]; //strlen(slask) + 1];
						strcpy(cgi -> value,val.c_str() );
						cgi -> path = NULL;
						addlist(&cgibase, (LIST *)cgi);
					}
					else
					if (*current_filename)
					{
DEB(						fprintf(fil,"Form:: save file<br>\n");)
					// read until m_strBoundary...
						FILE *fil;
						int out = 0;
						char c;
						char fn[200];
						sprintf(fn,"/tmp/%s",current_filename);
						if ((fil = fopen(fn, "wb")) != NULL)
						{
							fread(&c,1,1,stdin);
							while (!feof(stdin))
							{
								if (out)
								{
									fwrite(&tempcmp[tc],1,1,fil);
								}
								tempcmp[tc] = c;
								tc++;
								if (tc >= l + extra)
								{
									tc = 0;
									out = 1;
								}
//								fwrite(&c,1,1,fil);
								if (tc)
								{
									if (!strncmp(tempcmp + tc + extra, m_strBoundary, l - tc) &&
									    !strncmp(tempcmp, m_strBoundary + l - tc, tc))
									{
										break;
									}
								}
								else
								{
									if (!strncmp(tempcmp + extra, m_strBoundary, l))
									{
										break;
									}
								}
								fread(&c,1,1,stdin);
							}
							fclose(fil);

							cgi = new CGI;
							cgi -> name = new char[strlen(current_name) + 1];
							strcpy(cgi -> name,current_name);
							cgi -> value = new char[strlen(fn) + 1];
							strcpy(cgi -> value,fn);
							cgi -> path = new char[strlen(fn) + 1];
							strcpy(cgi -> path,fn);
							addlist(&cgibase, (LIST *)cgi);
						
							strcpy(slask, m_strBoundary);
							fgets(slask + strlen(slask), 200, stdin); // next line
						}
						else
						{
							// couldn't open file
DEB(							fprintf(fil,"Form:: couldn't create '%s'...<br>\n",fn);)
							break;
						}
					}
					else
					{
						// bad input?
DEB(						fprintf(fil,"Form:: bad input?<br>\n");)
						break;
					}
				}
				else
				{
					// Probably '<m_strBoundary>--'
DEB(					fprintf(fil,"Form:: end of boundary<br>\n");)
					break;
				}
DEB(				fprintf(fil,"Form:: ready for next field<br>\n");)
			} // while (!feof(stdin))
		} // if (m_strBoundary)
		if (tempcmp)
		{
			delete tempcmp;
		}
DEB(		fprintf(fil,"\n");)
	}
	else
	{
		int i = 0;
		int cl = c_l ? atoi(c_l) : -1;
		char c,chigh,clow;

		cgibase = NULL;
		current = NULL;

		*name = 0;

		fread(&c,1,1,stdin);
		cl--;
		while (cl >= 0 && !feof(stdin))
		{
			switch (c)
			{
				case '=': /* end of name */
					slask[i] = 0;
					i = 0;
					strcpy(name,slask);
					break;
				case '&': /* end of value */
					slask[i] = 0;
					i = 0;
					cgi = new CGI;
					cgi -> name = new char[strlen(name) + 1];
					strcpy(cgi -> name,name);
					cgi -> value = new char[strlen(slask) + 1];
					strcpy(cgi -> value,slask);
					cgi -> path = NULL;
DEB(					fprintf(fil,"\nform '%s' = '%s'<br>\n",name,slask);)
					addlist(&cgibase, (LIST *)cgi);
					break;
				case '+': /* space */
					slask[i++] = ' ';
					break;
				case '%': /* hex value */
					fread(&chigh,1,1,stdin);
					cl--;
					chigh -= 48;
					chigh &= 0xff - 32;
					if (chigh > 9)
						chigh -= 7;
					fread(&clow,1,1,stdin);
					cl--;
					clow -= 48;
					clow &= 0xff - 32;
					if (clow > 9)
						clow -= 7;
					slask[i++] = chigh * 16 + clow;
					break;
				default: /* just another char */
					slask[i++] = c;
					break;
			}
			//
			if (cl > 0)
			{
				fread(&c,1,1,stdin);
			}
			cl--;
		}
		slask[i] = 0;
		i = 0;
		cgi = new CGI;
		cgi -> name = new char[strlen(name) + 1];
		strcpy(cgi -> name,name);
		cgi -> value = new char[strlen(slask) + 1];
		strcpy(cgi -> value,slask);
		cgi -> path = NULL;
DEB(		fprintf(fil,"\nform '%s' = '%s'<br>\n",name,slask);)
		addlist(&cgibase, (LIST *)cgi);
	}
}


// Form(buffer,l) -- request_method GET

Form::Form(char *buffer,int l)
:m_strBoundary(NULL)
,raw(false)
{
	CGI *cgi;
	char slask[8888];
	char name[200];
	int i = 0;
	char c,chigh,clow;
	int ptr = 0;

	cgibase = NULL;
	current = NULL;

	*name = 0;

	ptr = 0;
	while (ptr < l)
	{
		c = buffer[ptr++];
		switch (c)
		{
			case '=': /* end of name */
				slask[i] = 0;
				i = 0;
				strcpy(name,slask);
				break;
			case '&': /* end of value */
				slask[i] = 0;
				i = 0;
				cgi = new CGI;
				cgi -> name = new char[strlen(name) + 1];
				strcpy(cgi -> name,name);
				cgi -> value = new char[strlen(slask) + 1];
				strcpy(cgi -> value,slask);
				cgi -> path = NULL;
				addlist(&cgibase, (LIST *)cgi);
				break;
			case '+': /* space */
				slask[i++] = ' ';
				break;
			case '%': /* hex value */
				chigh = buffer[ptr++];
				chigh -= 48;
				chigh &= 0xff - 32;
				if (chigh > 9)
					chigh -= 7;
				clow = buffer[ptr++];
				clow -= 48;
				clow &= 0xff - 32;
				if (clow > 9)
					clow -= 7;
				slask[i++] = chigh * 16 + clow;
				break;
			default: /* just another char */
				slask[i++] = c;
				break;
		}
	}
	slask[i] = 0;
	i = 0;
	cgi = new CGI;
	cgi -> name = new char[strlen(name) + 1];
	strcpy(cgi -> name,name);
	cgi -> value = new char[strlen(slask) + 1];
	strcpy(cgi -> value,slask);
	cgi -> path = NULL;
	addlist(&cgibase, (LIST *)cgi);
}

Form::~Form(void)
{
	CGI *cgi,*tmp;

	for (cgi = cgibase; cgi; cgi = tmp)
	{
		delete cgi -> name;
		delete cgi -> value;
		if (cgi -> path)
		{
			unlink(cgi -> path);
			delete cgi -> path;
		}
		tmp = cgi -> next;
		delete cgi;
	}
	if (m_strBoundary)
	{
		delete m_strBoundary;
	}
}


void Form::EnableRaw(bool b)
{
	raw = b;
}


void Form::strcpyval(char *v,char *value,size_t len)
{
	*v = 0;
	for (size_t i = 0; i < strlen(value); i++)
	{
		if (value[i] == '<')
		{
			if (strlen(v) < len - 4)
				sprintf(v + strlen(v),"&lt;");
		}
		else
		if (value[i] == '>')
		{
			if (strlen(v) < len - 4)
				sprintf(v + strlen(v),"&gt;");
		}
		else
		if (value[i] == '&')
		{
			if (strlen(v) < len - 5)
				sprintf(v + strlen(v),"&amp;");
		}
		else
		{
			if (strlen(v) < len - 1)
				sprintf(v + strlen(v),"%c",value[i]);
		}
	}
//	v[len - 1] = 0;
}


/* get names */

bool Form::getfirst(char *n,short len)
{
	current = cgibase;
	return getnext(n,len);
}

bool Form::getnext(char *n,short len)
{
	if (current)
	{
		strncpy(n,current -> name,len - 1);
		n[len - 1] = 0;
		current = current -> next;
		return true;
	} else
		*n = 0;
	return false;
}

/* get names and values */

bool Form::getfirst(char *n,short len,char *v,short vlen)
{
	current = cgibase;
	return getnext(n,len,v,vlen);
}

bool Form::getnext(char *n,short len,char *v,short vlen)
{
	if (current)
	{
		strncpy(n,current -> name,len - 1);
		n[len - 1] = 0;
		if (raw)
		{
			strncpy(v,current -> value,vlen - 1);
			v[vlen - 1] = 0;
		}
		else
		{
			strcpyval(v,current -> value,vlen);
		}
		current = current -> next;
		return true;
	} else
		*n = 0;
	return false;
}

/* get value */
int Form::getvalue(char *n,char *v,short len)
{
	CGI *cgi;
	int r = 0;

	for (cgi = cgibase; cgi; cgi = cgi -> next)
		if (!strcmp(cgi -> name,n))
			break;
	if (cgi)
	{
		if (raw)
		{
			strncpy(v,cgi -> value,len - 1);
			v[len - 1] = 0;
		}
		else
		{
			strcpyval(v,cgi -> value,len);
		}
		r++;
	} else
		*v = 0;

	return r;
}

std::string Form::getvalue(const std::string& n)
{
	for (CGI *cgi = cgibase; cgi; cgi = cgi -> next)
	{
		if (!strcmp(cgi -> name,n.c_str() ))
		{
			return cgi -> value;
		}
	}
	return "";
}

size_t Form::getlength(char *n)
{
	CGI *cgi;
	size_t l;

	for (cgi = cgibase; cgi; cgi = cgi -> next)
		if (!strcmp(cgi -> name,n))
			break;
	l = cgi ? strlen(cgi -> value) : 0;
	if (cgi && !raw)
	{
		for (size_t i = 0; i < strlen(cgi -> value); i++)
		{
			switch (cgi -> value[i])
			{
			case '<': // &lt;
			case '>': // &gt;
				l += 4;
				break;
			case '&': // &amp;
				l += 5;
				break;
			}
		}
	}
	return l; //cgi ? strlen(cgi -> value) : 0;
}


char *Form::GetBoundary()
{
	return m_strBoundary ? m_strBoundary : (char *)"";
}


