// WebForm.cpp
/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <string>
#include <stdarg.h>

#include "Form.h"
#include "Cookies.h"
#include <vector>
#include "WebForm.h"
#include "Web.h"


WebForm::WebForm(Web *web,const std::string &name)
:m_pclWeb(web)
,m_strFormName(name)
{
}


WebForm::~WebForm()
{
}


Form *WebForm::GetForm() 
{ 
	return m_pclWeb->GetForm(); 
}


Cookies *WebForm::GetCookies() 
{ 
	return m_pclWeb->GetCookies(); 
}


std::string WebForm::GetCgiName() 
{ 
	return m_pclWeb->GetCgiName(); 
}


Web *WebForm::GetWeb() 
{ 
	return m_pclWeb; 
}


std::string WebForm::GetDate()
{ 
	return m_pclWeb -> GetDate(); 
}


std::string WebForm::GetFormName()
{
	return m_strFormName;
}


void WebForm::nbprintf(char *format, ...)
{
	char slask[5000];
	va_list ap;

	va_start(ap, format);
	vsnprintf(slask, 5000, format, ap);
	va_end(ap);

	for (size_t i = 0; i < strlen(slask); i++)
	{
		if (slask[i] == ' ')
			printf("&nbsp;");
		else
			printf("%c",slask[i]);
	}
}


void WebForm::eprintf(char *format, ...)
{
	char slask[5000];
	va_list ap;

	va_start(ap, format);
	vsnprintf(slask, 5000, format, ap);
	va_end(ap);

	for (size_t i = 0; i < strlen(slask); i++)
	{
		switch (slask[i])
		{
		case '<':
			printf("&lt;");
			break;
		case '&':
			printf("&amp;");
			break;
		default:
			printf("%c",slask[i]);
		}
	}
}


